﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace vcsharp_uart_demo
{
    public partial class Form1 : Form
    {
        public string portdata;
        public Int32 numberOfBytesRead = 0;
        public Form1()
        {
            InitializeComponent();
        }

        /// Send button clicked
        private void button1_Click(object sender, EventArgs e)
        {
            serialPort.WriteLine(txtSend.Text);
        }
        /// On form load
        private void Form1_Load(object sender, EventArgs e)
        {
            //we load avalible ports to form
            string[] ports = SerialPort.GetPortNames();
            foreach (string port in ports)
            {
                this.cmbComPort.Items.Add(port);
            }
            /// Disable Send, Read and Close button 
            btnSend.Enabled = false;
            btnClose.Enabled = false;

            this.cmbComPort.SelectedIndex = 0;
            this.cmbBaudRate.SelectedIndex = 0;
            this.cmbDataSize.SelectedIndex = 1;
            this.cmbHandShake.SelectedIndex = 0;
            this.cmbParity.SelectedIndex = 0;
        }
        /// Open button clicked
        private void button3_Click(object sender, EventArgs e)
        {
            if (cmbBaudRate.SelectedItem != null && cmbComPort.SelectedItem != null)
            {
                serialPort.PortName = cmbComPort.SelectedItem.ToString();
                serialPort.BaudRate = Convert.ToInt32(cmbBaudRate.SelectedItem.ToString());

                if (cmbParity.Text == "none")
                {
                    serialPort.Parity = Parity.None;
                }
                else if (cmbParity.Text == "even")
                {
                    serialPort.Parity = Parity.Even;
                }
                else if (cmbParity.Text == "odd")
                {
                    serialPort.Parity = Parity.Odd;
                }
                else if (cmbParity.Text == "mark")
                {
                    serialPort.Parity = Parity.Mark;
                }
                serialPort.DataBits = Convert.ToInt32(cmbDataSize.Text.ToString());
                serialPort.StopBits = StopBits.One;
                serialPort.Handshake = Handshake.None;

                serialPort.ReadTimeout = 500;
                serialPort.WriteTimeout = 500;

                /// Get parity status

                try
                {
                    serialPort.Open();                         ///< Open COM port 1
                    btnSend.Enabled = true;
                    btnClose.Enabled = true;
                    btnOpen.Enabled = false;
                    cmbBaudRate.Enabled = false;
                    cmbComPort.Enabled = false;
                    cmbDataSize.Enabled = false;
                    cmbParity.Enabled = false;
                    cmbHandShake.Enabled = false;
                }
                catch
                {
                    MessageBox.Show("Could not open COM Port");
                }
            }
            else
            {
                MessageBox.Show("Please select a valid COM Port and Baud Rate");
            }
        }
        /// Close button clicked
        private void button4_Click(object sender, EventArgs e)
        {
            try
            {       
                serialPort.Close();                        ///< Close COM port 1
                cmbBaudRate.Enabled = true;
                cmbComPort.Enabled = true;
                cmbDataSize.Enabled = true;
                cmbParity.Enabled = true;
                cmbHandShake.Enabled = true;
                btnSend.Enabled = false;
                btnClose.Enabled = false;
                btnOpen.Enabled = true;
            }
            catch
            {
                MessageBox.Show("Could not close COM Port");
            }       
        }
        /// Read button clicked
        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                txtRead.Text = portdata.TrimEnd('\r');           ///< Display read data 
            }
            catch
            {
                MessageBox.Show("Buffer is Empty");
            }

        }

        private void label2_ParentChanged(object sender, EventArgs e)
        {

        }

        private void label1_ParentChanged(object sender, EventArgs e)
        {

        }

        private void cmbBaudRate_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
      
        private void serialPort_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            try
            {
                string portData = serialPort.ReadExisting();
                if (portData.Length != 0)
                {
                    this.Invoke((System.Threading.ThreadStart)delegate
                    {
                        txtRead.Text += portData;
                    });
                }
            }
            catch
            {
                MessageBox.Show("Could not read COM Port");
            }
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            this.txtRead.Text = "";
        }
    }
}